Attribute VB_Name = "Module2"
Option Explicit
Sub Save()
                Dim oTest As MapObjects2.Polygon
                Set oTest = Shape2Poly(MappointControl1.ActiveMap)
                
                If Not (oTest Is Nothing) Then
                    Call Save2SDE(oTest)
                End If
End Sub

Private Function Shape2Poly(objMap As MapPoint.Map) As MapObjects2.Polygon
On Error GoTo Shape2Poly_Err

    If objMap.Shapes.Count <> 1 Then
        MsgBox "Polygon is not correct"
        Set Shape2Poly = Nothing
        Exit Function
    End If
    
    
    Dim Poly As New MapObjects2.Polygon
    Dim pts As New MapObjects2.POINTS
    Dim pt As MapObjects2.Point
    Dim X As Double
    Dim y As Double
    Dim objLoc As MapPoint.Location
    Dim i As Integer
    
    Dim aVertices As Variant
    aVertices = objMap.Shapes.Item(1).Vertices
    
    For i = 0 To UBound(aVertices)
        Set objLoc = aVertices(i)
        Call CalcPos(objMap, objLoc, X, y)
        Set pt = New MapObjects2.Point
        pt.X = y
        pt.y = X
        pts.Add pt
    Next
    
    Poly.Parts.Add pts
    Set Shape2Poly = Poly
    
    Exit Function
    
Shape2Poly_Err:
    MsgBox "Shape2Poly_Err: " & Err.Description
    Set Shape2Poly = Nothing
End Function


Private Sub Save2SDE(objPoly As MapObjects2.Polygon)
    Dim address_d As Boolean
    Dim rs As MapObjects2.Recordset
    Dim pt As MapObjects2.Point
On Error GoTo errSave

    ' .............
    
    
    If Not PrvCoverLayer Is Nothing Then
        Set rs = PrvCoverLayer.SearchExpression("PrvID=" & Str(PrvID))
        If rs.EOF Then
            rs.AddNew
            rs.Fields("PrvID").Value = PrvID
            rs.Fields("PrvCode").Value = PrvCode
        Else
            rs.Edit
        End If

        Set rs.Fields("Shape").Value = objPoly

        rs.Update

    End If
    Exit Sub
errSave:
  MsgBox "errSave: " & Err.Description
End Sub
